%define anolis_release 2

Name:		tpm2-pkcs11
Version:	1.9.0
Release:        %{anolis_release}%{?dist}
Summary:	PKCS#11 interface for TPM 2.0 hardware
License:	BSD
URL:		https://github.com/tpm2-software/tpm2-pkcs11
Source0:        https://github.com/tpm2-software/%{name}/releases/download/%{version}/%{name}-%{version}.tar.gz
Source1:	https://github.com/tpm2-software/%{name}/releases/download/%{version}/%{name}-%{version}.tar.gz.asc
Source2:	gpgkey-8E1F50C1.gpg

BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	python3
BuildRequires:	libgcrypt-devel
BuildRequires:	libyaml-devel
BuildRequires:	openssl-devel
BuildRequires:	p11-kit-devel
BuildRequires:	sqlite-devel
BuildRequires:	tpm2-tools
BuildRequires:	tpm2-tss-devel
BuildRequires:	tpm2-abrmd-devel
# for tools
BuildRequires:	python3-devel
BuildRequires:	python3-setuptools
BuildRequires:	python3-pyasn1-modules
BuildRequires:	python3-pyyaml
BuildRequires:	python3-cryptography
BuildRequires:	python3-tpm2-pytss
# for tests
BuildRequires:	libcmocka-devel
BuildRequires:	dbus-daemon
BuildRequires:	python3-bcrypt
# for tarball signature verification
BuildRequires:	gnupg2

%description
PKCS #11 is a Public-Key Cryptography Standard that defines a standard method
to access cryptographic services from tokens/ devices such as hardware security
modules (HSM), smart cards, etc. In this project we intend to use a TPM2 device
as the cryptographic token.

%package tools
Summary: The tools required to setup and configure TPM2 for PKCS#11
Requires:	python3-cryptography
Requires:	python3-pyyaml
Requires:	python3-pyasn1-modules
Requires:	python3-tpm2-pytss

%description tools
The tools required to setup and configure TPM2 for PKCS#11.

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
gpgv2 --quiet --keyring %{SOURCE2} %{SOURCE1} %{SOURCE0}
%autosetup -n %{name}-%{version} -p1


%build
%configure --enable-unit
%{make_build}
cd tools
%py3_build


%install
%make_install
rm $RPM_BUILD_ROOT%{_libdir}/pkgconfig/tpm2-pkcs11.pc
cd tools
%py3_install
install -Dpm 755 tpm2_ptool $RPM_BUILD_ROOT%{_bindir}/tpm2_ptool

%generate_compatibility_deps


%check
make check
cd tools
%{__python3} setup.py test

%files
%license LICENSE
%{_datadir}/p11-kit/modules/tpm2_pkcs11.module
%%dir %{_libdir}/pkcs11
%{_libdir}/pkcs11/libtpm2_pkcs11.so
%{_libdir}/pkcs11/libtpm2_pkcs11.so.0*
%dir %{abidir}
%{abidir}/libtpm2_pkcs11.dump

%files tools
%{_bindir}/tpm2_ptool
%{python3_sitelib}/tpm2_pkcs11/*
%{python3_sitelib}/tpm2_pkcs11_tools-*/*

%files doc
%doc AUTHORS docs/*.md

%changelog
* Wed Mar 27 2024 Bo Ren <rb01097748@alibaba-inc.com> - 1.9.0-2
- Rebuild with python3.11

* Tue Apr 04 2023 happy_orange <songnannan@linux.alibaba.com> - 1.9.0-1
- init package
